import requests
import pathlib
import pandas as pd


def dl_5(csv_name):
    img_dir = pathlib.Path('img')
    if not img_dir.exists():
        img_dir.mkdir()
    directory = pathlib.Path(f'img/{csv_name.replace(".csv", "")}')
    if not directory.exists():
        directory.mkdir()
    true_preds = pd.read_csv(csv_name)
    true_preds_bcs = [pred[0] for pred in true_preds.values if pred[1]]

    for bc in true_preds_bcs:
        for i in range(1, 6):
            path = pathlib.Path(f'img/{csv_name.replace(".csv", "")}/{bc}-{i}.jpg')
            if path.exists():
                continue
            num = format(i, '08d')
            r = requests.get(f'https://iiif.onb.ac.at/images/ABO/{bc}/{num}/full/full/0/native.jpg')
            if r.status_code == 200:
                open(path, 'wb').write(r.content)


def create_subdirs_move_files(csv_name):
    true_preds = pd.read_csv(csv_name)
    true_preds_bcs = [pred[0] for pred in true_preds.values if pred[1]]

    for bc in true_preds_bcs:
        bc_dir = pathlib.Path(f'img/{csv_name.replace(".csv", "")}/{bc}')
        if not bc_dir.exists():
            bc_dir.mkdir()
        for i in range(1, 6):
            pathlib.Path(f'img/{csv_name.replace(".csv", "")}/{bc}-{i}.jpg').rename(bc_dir.joinpath(f'{bc}-{i}.jpg'))


def move_files_from_subdirs(csv_name):
    true_preds = pd.read_csv(csv_name)
    true_preds_bcs = [pred[0] for pred in true_preds.values if pred[1]]

    for bc in true_preds_bcs:
        for i in range(1, 6):
            cur_img = pathlib.Path(f'img/{csv_name.replace(".csv", "")}/{bc}/{bc}-{i}')
            cur_img.rename(f'img/{csv_name.replace(".csv", "")}/{bc}-{i}.jpg')
        bc_dir = pathlib.Path(f'img/{csv_name.replace(".csv", "")}/{bc}')
        bc_dir.rmdir()


if __name__ == '__main__':
    dl_5('all_predictions_1700-1738.csv')
    # create_subdirs_move_files('all_predictions_1700-1738.csv')
    # move_files_from_subdirs('all_predictions_1700-1738.csv')

