import pandas as pd
import matplotlib.pyplot as plt


def all_predictions_by_years():
    pred_data = pd.read_csv('Prediction_Counts_1501-1738.csv')
    years = pred_data['Years']
    Pos = pred_data['Positive']
    Neg = pred_data['Negative']
    width = 0.35
    fig, ax = plt.subplots()
    P = ax.bar(years, Neg, width, label='Negative')
    ax.bar_label(P, label_type='center')
    N = ax.bar(years, Pos, width, bottom=Neg, label='Positive')
    ax.bar_label(N, label_type='center')
    ax.set_ylabel('Prediction')
    ax.set_title('Predictions by years')
    ax.legend()
    plt.show()


def true_and_false_positive_predictions():
    pred_data = pd.read_csv('Prediction_Counts_1501-1738.csv')
    years = pred_data['Years']
    Pos = pred_data['TruePositive']
    Neg = pred_data['FalsePositive']
    width = 0.8
    fig, ax = plt.subplots()
    TP = ax.bar(years, Pos, width, label='Richtig positiv')
    ax.bar_label(TP, label_type='center')
    FP = ax.bar(years, Neg, width, bottom=Pos, label='Falsch positiv')
    ax.bar_label(FP, label_type='center')
    ax.set_ylabel('Positive Vorhersagen')
    ax.set_title('Positive Vorhersagen aufgeschlüsselt nach Jahren')
    ax.legend()
    plt.show()


if __name__ == '__main__':
    # all_predictions_by_years()
    true_and_false_positive_predictions()
